## NMDeviceEthernet

NMDeviceEthernet

## Functions

GQuark | nm_device_ethernet_error_quark ()
GObject * | nm_device_ethernet_new ()
const char * | nm_device_ethernet_get_hw_address ()
const char * | nm_device_ethernet_get_permanent_hw_address ()
guint32 | nm_device_ethernet_get_speed ()
gboolean | nm_device_ethernet_get_carrier ()

## Properties

gboolean | carrier | Read
gchar * | hw-address | Read
gchar * | perm-hw-address | Read
guint | speed | Read

## Types and Values

enum | NMDeviceEthernetError
#define | NM_DEVICE_ETHERNET_ERROR
#define | NM_DEVICE_ETHERNET_HW_ADDRESS
#define | NM_DEVICE_ETHERNET_PERMANENT_HW_ADDRESS
#define | NM_DEVICE_ETHERNET_SPEED
#define | NM_DEVICE_ETHERNET_CARRIER

## Object Hierarchy

        GObject
        ╰── NMObject
            ╰── NMDevice
                ╰── NMDeviceEthernet

## Description

## Functions

### nm_device_ethernet_error_quark ()

    GQuark
    nm_device_ethernet_error_quark (void);

Registers an error quark for NMDeviceEthernet if necessary.

#### Returns

the error quark used for NMDeviceEthernet errors.

### nm_device_ethernet_new ()

    GObject *
    nm_device_ethernet_new (DBusGConnection *connection,
                            const char *path);

Creates a new NMDeviceEthernet.

#### Parameters

connection | the DBusGConnection |
path | the DBus object path of the device |

#### Returns

a new device.

[transfer full]

### nm_device_ethernet_get_hw_address ()

    const char *
    nm_device_ethernet_get_hw_address (NMDeviceEthernet *device);

Gets the active hardware (MAC) address of the NMDeviceEthernet

#### Parameters

device | a NMDeviceEthernet |

#### Returns

the active hardware address. This is the internal string used by the device, and must not be modified.

### nm_device_ethernet_get_permanent_hw_address ()

    const char *
    nm_device_ethernet_get_permanent_hw_address
                                   (NMDeviceEthernet *device);

Gets the permanent hardware (MAC) address of the NMDeviceEthernet

#### Parameters

device | a NMDeviceEthernet |

#### Returns

the permanent hardware address. This is the internal string used by the device, and must not be modified.

### nm_device_ethernet_get_speed ()

    guint32
    nm_device_ethernet_get_speed (NMDeviceEthernet *device);

Gets the speed of the NMDeviceEthernet.

#### Parameters

device | a NMDeviceEthernet |

#### Returns

the speed of the device

### nm_device_ethernet_get_carrier ()

    gboolean
    nm_device_ethernet_get_carrier (NMDeviceEthernet *device);

Whether the device has carrier.

#### Parameters

device | a NMDeviceEthernet |

#### Returns

`TRUE` if the device has carrier

## Types and Values

### enum NMDeviceEthernetError

#### Members

NM_DEVICE_ETHERNET_ERROR_UNKNOWN | unknown or unclassified error |
NM_DEVICE_ETHERNET_ERROR_NOT_ETHERNET_CONNECTION | the connection was not of Ethernet or PPPoE type |
NM_DEVICE_ETHERNET_ERROR_INVALID_ETHERNET_CONNECTION | the Ethernet connection was invalid |
NM_DEVICE_ETHERNET_ERROR_INVALID_DEVICE_MAC | the device's MAC was invalid |
NM_DEVICE_ETHERNET_ERROR_MAC_MISMATCH | the MACs of the connection and the device mismatched |

### NM_DEVICE_ETHERNET_ERROR

    #define NM_DEVICE_ETHERNET_ERROR nm_device_ethernet_error_quark ()

### NM_DEVICE_ETHERNET_HW_ADDRESS

    #define NM_DEVICE_ETHERNET_HW_ADDRESS  "hw-address"

### NM_DEVICE_ETHERNET_PERMANENT_HW_ADDRESS

    #define NM_DEVICE_ETHERNET_PERMANENT_HW_ADDRESS "perm-hw-address"

### NM_DEVICE_ETHERNET_SPEED

    #define NM_DEVICE_ETHERNET_SPEED       "speed"

### NM_DEVICE_ETHERNET_CARRIER

    #define NM_DEVICE_ETHERNET_CARRIER     "carrier"

## Property Details

### The `“carrier”` property

      “carrier”                  gboolean

Whether the device has carrier.

Flags: Read

Default value: FALSE

### The `“hw-address”` property

      “hw-address”               gchar *

The active hardware (MAC) address of the device.

Flags: Read

Default value: NULL

### The `“perm-hw-address”` property

      “perm-hw-address”          gchar *

The permanent hardware (MAC) address of the device.

Flags: Read

Default value: NULL

### The `“speed”` property

      “speed”                    guint

The speed of the device.

Flags: Read

Default value: 0